/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX Sistemi Integrati. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2007. 
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* ===================================================================== */


package cdmw.logging.test.testfunctionlogger;

import cdmw.logging.*;
// import cdmw.common.*;
import static cdmw.logging.FunctionLogger.*;

public class FunctionLoggerUser {
    private Logger logger;
    private LevelType level;

    public FunctionLoggerUser (Logger logger) {
        this.logger = logger;
        this.level = new LevelType ();
    }

    public void op1 () {
        CDMW_LOG_FUNCTION(this.logger, "");
        CDMW_LOG_FUNCTION_RETURN(this.logger);    
    }

    public int opReturn (int a, int b) {
        CDMW_LOG_FUNCTION(this.logger, ""+a+"+"+b);
        CDMW_LOG_FUNCTION_RETURN(this.logger, a+b);
        return a+b;
    }

    public void opException (int input) throws Exception {
        CDMW_LOG_FUNCTION(this.logger, "Input="+input);
        
        Exception ex = 
            new Exception (String.valueOf(input));
        CDMW_LOG_FUNCTION_EXCEPTION(this.logger, ex);
        
        throw ex;
    }
}
