#!/bin/ksh
# =====================================================================
# This file is part of CARDAMOM (R) which is jointly developed by THALES
# and SELEX Sistemi Integrati. It is derivative work based on PERCO 
# Copyright (C) THALES 2000-2003. All rights reserved.
# Copyright (C) THALES 2004-2005. All rights reserved.
# Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2007. 
# All rights reserved.
# 
# CARDAMOM is free software; you can redistribute it and/or modify it
# under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
# License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with CARDAMOM; see the file COPYING. If not, write to the
# Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# =====================================================================

print_root_error()
{
    echo " "
    echo "Error: you should be root to run this script !"
    exit -1
}

print_host_error()
{
    echo " "
    echo "Error: you should be on host @hostname1val@ to run this script !"
    exit -1
}

if [ `whoami` != root ]; then
    print_root_error
fi

if [ `hostname` != @hostname1val@ ]; then
    print_host_error
fi

HOSTS="@hostname1val@ @hostname2val@ @hostname3val@ @hostname4val@ @hostname5val@"

NEW_TEST=${1}

CDMW_TEST_OUT=${CDMW_TEST_OUT:-@config.install.dir@/TEST-RESULTS}
TODAY=$(date +%Y%m%d)
NOW=$(date +%H%M)

#get old test id (Q-xxx)
TEST_ID=$(grep "export CDMW_TEST_ID" @config.install.dir@/bin/log.sh | sed "s%export CDMW_TEST_ID=%%")

SAVE_DIR="${CDMW_TEST_OUT}/${TEST_ID}-${TODAY}-${NOW}"

# no copy if no log has been performed before
if [ ${TEST_ID} == "Q-XXX" ]; then
    echo "No test performed before : old logs not gathered."
else
    echo "Gathering log files for ${TEST_ID}."
    echo "Creating directory ${SAVE_DIR} if needed."
    mkdir -p ${SAVE_DIR}
    chmod 777 ${SAVE_DIR}

    for host_i in ${HOSTS}; do
        echo "Saving ${TEST_ID} log files from ${hots_i} to @hostname1val@"
        scp -r -p ${host_i}:${CDMW_TEST_OUT}/${TEST_ID}_* ${SAVE_DIR}
        ssh ${host_i} "rm -rf ${CDMW_TEST_OUT}/${TEST_ID}_*"
    done
fi

for host_i in ${HOSTS}; do
    echo "updating test id in log.sh on ${host_i}"
    ssh ${host_i} sed -i "s%CDMW_TEST_ID=.*%CDMW_TEST_ID=${NEW_TEST}%" @config.install.dir@/bin/log.sh
done

