#!/bin/sh
# 
ID_=[10/09/2007]

if [ "$#" != "3" ]
then
  echo "Usage: $0 [process name/number] [# iterations] [output file name]"
  echo $ID_
  exit 1
fi
# number of iterations
NITER="$2"
# Output file name
FNAME="$3"
# Process PID
PROCESS_ID=`ps aux | grep "$1" | grep -vw grep | grep -vw use_cpu | head -1 | tr -s [:blank:] | sed 's/^[ ]*//' |  cut -d' ' -f2`
echo "PRCESS NAME***: " $1
echo "PROCESS ID***: " $PROCESS_ID
if [ "$PROCESS_ID" == "" ]
then
  echo "ERROR: process $1 not found!"
  exit 1
fi

COMMAND=`top -p $PROCESS_ID -b -d 0.01 -n $NITER | grep -w $PROCESS_ID | tr -s [:blank:] | sed 's/^[ ]*//' | cut -d' ' -f 9`
if [ "$COMMAND" == "" ]
then
  echo "ERROR: unable to read cpu size for process $1."
  exit 1
fi
if [ -f "$3" ]
then
    echo "Overwriting file $3..."
else
    echo "Creating file $3..."
fi

echo $COMMAND > $FNAME
exit 0

