/* ===================================================================== */
/*
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX Sistemi Integrati. It is derivative work based on PERCO 
 * Copyright (C) THALES 2000-2003. All rights reserved.
 * Copyright (C) THALES 2004-2005. All rights reserved.
 * Copyright (C) SELEX SISTEMI INTEGRATI and THALES 2006-2007. 
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with CARDAMOM; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* ===================================================================== */

package cdmw.ccm_context;

import com.thalesgroup.CdmwPlatformMngt.*;
import com.acme.TestCcmContext.*;
import cdmw.ossupport.OS;

//
// IDL:thalesgroup.com/TestCcmContext/CCM_Client:1.0
//
public class CCMClientImpl extends org.omg.CORBA.LocalObject
    implements Session_CCM_Client{
    //extends CCMTestComponentContextImpl
    //    implements com.acme.TestCcmContext.CCM_Client {
    
    private int indice = 0;

    private String name = "";
    
    //    private com.acme.TestCcmContext.CCM_TestComponentContext display = new CCMTestComponentContextImpl();

    public CCMClientImpl() {
        this.m_sessionContext = null;
    }

    // session context
    private CCM_Client_Context m_sessionContext;

    //
    // IDL:thalesgroup.com/TestCcmContext/CCM_Client/get_for_clients:1.0
    //
    //    public com.acme.TestCcmContext.CCM_TestComponentContext get_for_clients() {
    //        return this.display;
    //    }

    //
    // IDL:thalesgroup.com/TestCcmContext/CCM_Client_Executor/name:1.0
    //
    public String name() {
        // TODO: Implementation
        return this.name;
    }

    public void name(String name) {
        this.name = name;
    }


    public com.acme.TestCcmContext.CCM_TestComponentContext get_test_component_context(){
        return null; 
    }   


    public void set_session_context(org.omg.Components.SessionContext ctx)
    {
        java.lang.System.out.println("   ... CCMClientImpl::set_session_context called!");
        this.m_sessionContext = CCM_Client_ContextHelper.narrow(ctx);
    }
 
    public CCM_Client_Context getContext()
    {
        return this.m_sessionContext;
    }


    public void ccm_activate() {


        org.omg.CORBA.Object obj = null;
        try
            {    
                obj = m_sessionContext.resolve_service_reference(cdmw.platformmngt.PlatformInterface.MANAGED_PROCESS_CONTEXT_NAME);

            }
        catch (Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContext ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ProcessContextHelper.narrow(obj);
    
        com.thalesgroup.CdmwPlatformMngt.External.System sys = ctx.the_system();
        com.thalesgroup.CdmwPlatformMngt.External.Process proc = ctx.the_process();
        com.thalesgroup.CdmwPlatformMngt.External.Host host = ctx.the_host();
        com.thalesgroup.CdmwPlatformMngt.External.Application app = ctx.the_application();
        com.thalesgroup.CdmwPlatformMngt.ManagedElement managed_element = ctx.the_managed_element();
        /*java.lang.System.out.println("-- system name:" + sys.name() + "-- process name:" +proc.name() +
         "-- application name:" + app.name() + "-- host name:"+ host.name() + 
         "-- managed element name:" + managed_element.name()); 
        */ 

        java.lang.System.out.println("Testing Managed Component Context operations");
        try
            {
                obj = m_sessionContext.resolve_service_reference("ManagedComponentContext");

            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }
 
        com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContext comp_ctx = com.thalesgroup.CdmwPlatformMngt.ManagedElementContexts.ComponentContextHelper.narrow(obj);
 
 
        sys = comp_ctx.the_system();
        proc = comp_ctx.the_process();
        host = comp_ctx.the_host();
        app = comp_ctx.the_application();
        managed_element = comp_ctx.the_managed_element();

        cdmw.common.Assert.check(sys.name().equals("S1"));

        cdmw.common.Assert.check(proc.name().equals("TestComponentContextProcessClient1") ); 

        cdmw.common.Assert.check(managed_element.name().equals("ClientInst"));

        cdmw.common.Assert.check(app.name().equals("CcmTestComponentContextApplication"));

        cdmw.common.Assert.check(host.name().equals(OS.getHostname()));

/*     java.lang.System.out.println("-- system name:" + sys.name() + "-- process name:" +proc.name() +
                                     "-- application name:" + app.name() + "-- host name:"+ host.name() +
                                     "-- managed element name:" + managed_element.name());
*/
        Client thisComponent = null;
        try {
            // narrow context in SessionContext for get_CCM_objet() access
            org.omg.Components.SessionContext session_ctx =
                org.omg.Components.SessionContextHelper.narrow(m_sessionContext);

            // call SessionContext.get_CCM_objet()
            obj = session_ctx.get_CCM_object();

            thisComponent = ClientHelper.narrow(obj);

            cdmw.common.Assert.check(thisComponent != null);

        } catch (org.omg.CORBA.UserException e) {
            java.lang.System.err.println("UserException during get_CCM_Object() :" + e);
            cdmw.common.Assert.check(false);
        } catch (org.omg.CORBA.SystemException e) {
            java.lang.System.err.println("SystemException during get_CCM_Object() :" + e);
            cdmw.common.Assert.check(false);
        }
 

        // get connected server
        TestComponentContext test_ctx =
            this.m_sessionContext.get_connection_test_server();
 
        String str = "operation_parameter";
        if (test_ctx == null)
            {
                java.lang.System.out.println("pointer TestComponentContext  null !");
                cdmw.common.Assert.check(false);
            }
             
        try
            {
                obj = this.m_sessionContext.resolve_service_reference("ManagedComponentContext");
            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        java.lang.System.out.println("*** Registering TestCcmContext_Client observer *** ");
        sys.register_observer("TestCcmContext_Client", thisComponent);
        java.lang.System.out.println("*** Observer Registerd *** ");

        java.lang.System.out.println("*** Registering TestCcmContext_Client observer *** ");
        
        java.lang.System.out.println("*** Testing notify_message *** ");
        ctx.notify_message(0, "CLIENT_NOTIFICATION_MESSAGE");
        try
            {
                OS.sleep(1000);
            }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        java.lang.System.out.println("*** Testing notify_user_event *** ");
        org.omg.CORBA.Any any_data = org.omg.CORBA.ORB.init().create_any();
        any_data.insert_string("any_dummy");
        try
            {
                ctx.notify_user_event (any_data);
            }
        catch(org.omg.CORBA.NO_IMPLEMENT ex)
            {
                java.lang.System.out.println(ex.toString());
            }

        try{
            java.lang.System.out.println("*** Testing notify_fatal_error *** ");
            ctx.notify_fatal_error("CLIENT_NOTIFY_FATAL_ERROR");
        }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex);
            }

        try{
            sys.unregister_observer("TestCcmContext_Client");
        }
        catch(Exception ex)
            {
                java.lang.System.out.println(ex);
            }   

        try{
            // makes the server exit with code 10
            test_ctx.test_operation(str);
        }
        catch(org.omg.CORBA.SystemException ex)
            {
                java.lang.System.out.println( "***" + ex + " caught SystemException because component Server has crashed! ***");
            }

        java.lang.System.out.println("### All verification are ok ###");
    }

    public void ccm_remove() {
        java.lang.System.out.println("***  ccm_remove() ***");
    }
  
   
    public void ccm_passivate() {
        java.lang.System.out.println("***  ccm_passivate()  ***");
    }



    public com.thalesgroup.CdmwPlatformMngt.External.RedundancyGroup get_server_group()
    {
        throw new org.omg.CORBA.NO_IMPLEMENT (cdmw.orbsupport.ExceptionMinorCodes.NO_IMPLEMENT, 
                                              org.omg.CORBA.CompletionStatus.COMPLETED_NO); 
    } 


    public void _notify(Event e) {
        java.lang.System.out.println(e.to_string());   
    }

}

